{
ZZZZZZ 5.0, a chess program.
Copyright (C) 1998 G. Wiesenekker
E-mail: gijsbert.wiesenekker@wxs.nl
http://home.wxs.nl/~gijsbert.wiesenekker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}
unit DebugScore;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids;

type
  TDebugScoreForm = class(TForm)
    AttackGrid: TStringGrid;
    OutputMemo: TMemo;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DebugScoreForm: TDebugScoreForm;
  procedure DisplayScore;

implementation

uses Chess, Score;

{$R *.lfm}

procedure DrawAttack;
var
  Col, Row: Integer;
begin
  for Col := 0 to 7 do
  begin
  	for Row := 0 to 7 do
    begin
    	DebugScoreForm.AttackGrid.Cells[Col, Row] :=
      	IntToStr(AttackBoard[White][RowColToBoardIndex[Row, Col]]) + '/' +
        IntToStr(AttackBoard[Black][RowColToBoardIndex[Row, Col]]);
    end;
  end;
end;

procedure DisplayScore;
var
	WhiteScore, BlackScore: ScoreRecord;
begin
  DebugScoreForm.OutputMemo.Lines.Clear;
  ShowScore := True;
  SetScore(White, Black, WhiteScore);
	DrawAttack;
  DebugScoreForm.OutputMemo.Lines.Add(ScoreToString(WhiteScore));
  ShowScore := False;
	SetScore(Black, White, BlackScore);
  if WhiteScore.MatScore <> -BlackScore.MatScore then
  	raise EChessError.Create('Mat score error');
  if WhiteScore.PosScore <> -BlackScore.PosScore then
  	raise EChessError.Create('Pos score error');
  if WhiteScore.VisitScore <> -BlackScore.VisitScore then
  	raise EChessError.Create('Visit score error');
end;

end.
