{
ZZZZZZ 5.0, a chess program.
Copyright (C) 1998 G. Wiesenekker
E-mail: gijsbert.wiesenekker@wxs.nl
http://home.wxs.nl/~gijsbert.wiesenekker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}
unit DebugVisit;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, ComCtrls;

type
  TDebugVisitForm = class(TForm)
    OkButton: TButton;
    VisitGrid: TStringGrid;
    KindRadioGroup: TRadioGroup;
    PawnTrackBar: TTrackBar;
    PawnCountLabel: TLabel;
    ColourRadioGroup: TRadioGroup;
    procedure KindRadioGroupClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PawnTrackBarChange(Sender: TObject);
    procedure ColourRadioGroupClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DebugVisitForm: TDebugVisitForm;

implementation

uses Chess, Score;

var
	iKind: BoardKindEnum;
  iColour: BoardColourEnum;
  nPawn: Integer;

{$R *.lfm}

procedure DrawVisit;
var
  Col, Row: Integer;
begin
  for Col := 0 to 7 do
  begin
  	for Row := 0 to 7 do
    begin
    	DebugVisitForm.VisitGrid.Cells[Col, Row] :=
      	IntToStr(Visit[iColour, iKind][nPawn, nPawn][RowColToBoardIndex[Row, Col]]) + '/' +
				IntToStr(NormalVisit[iColour, iKind][nPawn, nPawn][RowColToBoardIndex[Row, Col]]);
    end;
  end;
end;

procedure TDebugVisitForm.KindRadioGroupClick(Sender: TObject);
begin
	if KindRadioGroup.ItemIndex = 0 then
  	iKind := Pawn
  else if KindRadioGroup.ItemIndex = 1 then
  	iKind := Knight
  else if KindRadioGroup.ItemIndex = 2 then
  	iKind := Bishop
  else if KindRadioGroup.ItemIndex = 3 then
  	iKind := Rook
  else if KindRadioGroup.ItemIndex = 4 then
  	iKind := Queen
  else
  	iKind := King;
  DrawVisit;
end;

procedure TDebugVisitForm.PawnTrackBarChange(Sender: TObject);
begin
	PawnCountLabel.Caption := 'Pawns: ' + IntToStr(PawnTrackBar.Position);
  nPawn := PawnTrackBar.Position;
  DrawVisit;
end;

procedure TDebugVisitForm.FormShow(Sender: TObject);
begin
	iKind := Pawn;
  iColour := White;
	PawnTrackBar.Position := 8;
	PawnTrackBarChange(nil);
end;

procedure TDebugVisitForm.ColourRadioGroupClick(Sender: TObject);
begin
	if ColourRadioGroup.ItemIndex = 0 then
  	iColour := White
  else if ColourRadioGroup.ItemIndex = 1 then
  	iColour := Black;
  DrawVisit;
end;

end.
