{
ZZZZZZ 5.0, a chess program.
Copyright (C) 1998 G. Wiesenekker
E-mail: gijsbert.wiesenekker@wxs.nl
http://home.wxs.nl/~gijsbert.wiesenekker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}
unit Prefs;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TPrefsForm = class(TForm)
    PrefsPageControl: TPageControl;
    FontSheet: TTabSheet;
    FontSizeEdit: TEdit;
    SizeLabel: TLabel;
    OkButton: TButton;
    CancelButton: TButton;
    DebugSheet: TTabSheet;
    DebugCheckBox: TCheckBox;
    CacheSheet: TTabSheet;
    CacheSizeEdit: TEdit;
    ScoreCacheSizeEdit: TEdit;
    CacheLabel: TLabel;
    ScoreCacheLabel: TLabel;
    QuiesCacheSizeEdit: TEdit;
    QuiesCacheLabel: TLabel;
    SearchSheet: TTabSheet;
    NullMoveCheckBox: TCheckBox;
    CacheCheckBox: TCheckBox;
    LazyCheckBox: TCheckBox;
    SoundSheet: TTabSheet;
    SoundCheckBox: TCheckBox;
    ExtendCheckBox: TCheckBox;
    ColorSheet: TTabSheet;
    WhiteBackGroundLabel: TLabel;
    BlackBackGroundLabel: TLabel;
    WhiteBackGroundPanel: TPanel;
    BlackBackGroundPanel: TPanel;
    ColorDialog: TColorDialog;
    procedure FontSizeEditChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure BlackBackGroundPanelClick(Sender: TObject);
    procedure WhiteBackGroundPanelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PrefsForm: TPrefsForm;

implementation

uses Chess, Main, Utils;

{$R *.lfm}

var
	PrevText: AnsiString;

procedure TPrefsForm.FontSizeEditChange(Sender: TObject);
var
	Temp: Integer;
begin
	if (FontSizeEdit.Text = '') then
  begin
  	PrevText := FontSizeEdit.Text;
  end
  else
  begin
    try
      Temp := StrToInt(FontSizeEdit.Text);
      PrevText := FontSizeEdit.Text;
    except
      on EConvertError do
      begin
        FontSizeEdit.Text := PrevText;
      end;
    end;
  end;
end;

procedure TPrefsForm.FormShow(Sender: TObject);
begin
	FontSizeEdit.Text := IntToStr(FontSize);
  CacheSizeEdit.Text := IntToStr(CacheSize);
  QuiesCacheSizeEdit.Text := IntToStr(QuiesCacheSize);
  ScoreCacheSizeEdit.Text := IntToStr(ScoreCacheSize);
 	DebugCheckBox.Checked := Debug;
 	NullMoveCheckBox.Checked := Options.UseNullMove;
 	CacheCheckBox.Checked := Options.UseCache;
 	LazyCheckBox.Checked := Options.UseLazy;
  SoundCheckBox.Checked := Options.UseSounds;
  ExtendCheckBox.Checked := Options.ExtendCheck;
	//
  WhiteBackGroundPanel.Color := WhiteBackGroundColor;
  BlackBackGroundPanel.Color := BlackBackGroundColor;
end;

procedure TPrefsForm.OkButtonClick(Sender: TObject);
begin
	if (FontSizeEdit.Text <> '') then
  begin
  	FontSize := StrToInt(FontSizeEdit.Text);
  	WriteRegValString(RegValFontSize, IntToStr(FontSize));
    MainForm.BoardGrid.Font.Size := FontSize;
    AdjustStringGrid(MainForm.BoardGrid, AllColumns, True, 'P');
  end;
  Options.UseNullMove := NullMoveCheckBox.Checked;
  Options.UseCache := CacheCheckBox.Checked;
  Options.UseLazy := LazyCheckBox.Checked;
  Options.UseSounds := SoundCheckBox.Checked;
  Options.ExtendCheck := ExtendCheckBox.Checked; 
  Debug := DebugCheckBox.Checked;
	WriteRegValString(RegValDebug, BoolToStr(Debug));
  CacheSize := StrToInt(CacheSizeEdit.Text);
  QuiesCacheSize := StrToInt(QuiesCacheSizeEdit.Text);
  ScoreCacheSize := StrToInt(ScoreCacheSizeEdit.Text);
  WriteRegValString(RegValCacheSize, IntToStr(CacheSize));
  WriteRegValString(RegValQuiesCacheSize, IntToStr(QuiesCacheSize));
  WriteRegValString(RegValScoreCacheSize, IntToStr(ScoreCacheSize));
  //
  WhiteBackGroundColor := WhiteBackGroundPanel.Color;
  BlackBackGroundColor := BlackBackGroundPanel.Color;
  WriteRegValString(RegValWhiteBackGroundColor, IntToStr(WhiteBackGroundColor));
  WriteRegValString(RegValBlackBackGroundColor, IntToStr(BlackBackGroundColor));
end;

procedure TPrefsForm.BlackBackGroundPanelClick(Sender: TObject);
begin
	if ColorDialog.Execute then
  begin
  	BlackBackGroundPanel.Color := ColorDialog.Color;
  end;
end;

procedure TPrefsForm.WhiteBackGroundPanelClick(Sender: TObject);
begin
	if ColorDialog.Execute then
  begin
  	WhiteBackGroundPanel.Color := ColorDialog.Color;
  end;
end;

end.
