{
ZZZZZZ 5.0, a chess program.
Copyright (C) 1998 G. Wiesenekker
E-mail: gijsbert.wiesenekker@wxs.nl
http://home.wxs.nl/~gijsbert.wiesenekker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}
unit Setup;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, ExtCtrls;

type
  TSetupForm = class(TForm)
    SetupGrid: TStringGrid;
    OkButton: TButton;
    CancelButton: TButton;
    ColourGroup: TRadioGroup;
    ChoiceGrid: TStringGrid;
    CastlingGroupBox: TGroupBox;
    WhiteShortCastleCheckBox: TCheckBox;
    WhiteLongCastleCheckBox: TCheckBox;
    BlackShortCastleCheckBox: TCheckBox;
    BlackLongCastleCheckBox: TCheckBox;
    ClearButton: TButton;
    procedure SetupGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormShow(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure ChoiceGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ClearButtonClick(Sender: TObject);
    procedure SetupGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SetupGridDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure SetupGridDragDrop(Sender, Source: TObject; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SetupForm: TSetupForm;

implementation

{$R *.lfm}

uses Chess, Utils, Main;
var
	DragCol, DragRow: Integer;

procedure TSetupForm.SetupGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
	StringGridDrawCell(SetupGrid, ACol, ARow, Rect, State);
end;

procedure TSetupForm.FormShow(Sender: TObject);
var
	Col, Row: Integer;
begin
	AdjustStringGrid(SetupGrid, AllColumns, True, 'P');
	AdjustStringGrid(ChoiceGrid, AllColumns, True, 'P');
	ChoiceGrid.Cells[0, 0] := wP;
	ChoiceGrid.Cells[0, 1] := wN;
	ChoiceGrid.Cells[0, 2] := wB;
	ChoiceGrid.Cells[0, 3] := wR;
	ChoiceGrid.Cells[0, 4] := wQ;
	ChoiceGrid.Cells[0, 5] := wK;
	ChoiceGrid.Cells[0, 6] := nE;
	ChoiceGrid.Cells[1, 0] := bP;
	ChoiceGrid.Cells[1, 1] := bN;
	ChoiceGrid.Cells[1, 2] := bB;
	ChoiceGrid.Cells[1, 3] := bR;
	ChoiceGrid.Cells[1, 4] := bQ;
	ChoiceGrid.Cells[1, 5] := bK;
	ChoiceGrid.Cells[1, 6] := nE;
	for Col := 0 to 7 do
  begin
  	for Row := 0 to 7 do
    begin
    	SetupGrid.Cells[Col, Row] := GameBoardGrid[Row, Col];
    end;
  end;
  if (GameColour = White) then
  	ColourGroup.ItemIndex := 0
  else
  	ColourGroup.ItemIndex := 1;
end;

procedure TSetupForm.OkButtonClick(Sender: TObject);
var
	Col, Row: Integer;
begin
  for Row := 0 to 7 do
  begin
    for Col := 0 to 7 do
    begin
      GameBoardGrid[Col, Row] := SetupGrid.Cells[Row, Col];
    end;
  end;
  if (ColourGroup.ItemIndex = 0) then
    GameColour := White
  else
    GameColour := Black;
end;

procedure TSetupForm.ChoiceGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
	StringGridDrawCell(ChoiceGrid, ACol, ARow, Rect, State);
end;

procedure TSetupForm.ClearButtonClick(Sender: TObject);
var
	Col, Row: Integer;
begin
	for Col := 0 to 7 do
  begin
  	for Row := 0 to 7 do
    begin
    	SetupGrid.Cells[Col, Row] := nE;
    end;
  end;
end;

procedure TSetupForm.SetupGridMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	SetupGrid.MouseToCell(X, Y, DragCol, DragRow);
	SetupGrid.BeginDrag(True);
end;

procedure TSetupForm.SetupGridDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
	//
end;

procedure TSetupForm.SetupGridDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
	Col, Row: Integer;
begin
	SetupGrid.MouseToCell(X, Y, Col, Row);
  if (Col = DragCol) and (Row = DragRow) then
  begin
  	if SetupGrid.Cells[SetupGrid.Col, SetupGrid.Row] =
      ChoiceGrid.Cells[ChoiceGrid.Col, ChoiceGrid.Row] then
		begin
      SetupGrid.Cells[DragCol, DragRow] := nE;
    end
    else
    	SetupGrid.Cells[SetupGrid.Col, SetupGrid.Row] :=
      	ChoiceGrid.Cells[ChoiceGrid.Col, ChoiceGrid.Row];
  end
  else
  begin
    SetupGrid.Cells[Col, Row] :=
      SetupGrid.Cells[DragCol, DragRow];
    SetupGrid.Cells[DragCol, DragRow] := nE;
  end;
end;

end.
